package fw.facade;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;

public abstract class AbstractFilter implements Filter {

    private String nextPage;

    @Override
    public void destroy() {
    }

    @Override
    public void doFilter(ServletRequest request, ServletResponse response,
            FilterChain fch) throws IOException, ServletException {
        try {
            PreFilter(request);
        } catch (IOException e) {
            throw e;
        } catch (ServletException e) {
            throw e;
        }
        Process(request, response, (ChainFilter) fch);
        PostFilter(request);

    }

    @Override
    public void init(FilterConfig fc) throws ServletException {
    }

    public abstract void PreFilter(ServletRequest request) throws IOException, ServletException;

    public abstract void PostFilter(ServletRequest request);

    public void Process(ServletRequest request, ServletResponse response, ChainFilter chain) {
        if (nextPage != null) {
            chain.setNextPage(nextPage);
        }
        try {
            chain.doFilter(request, response);
        } catch (Exception e) {
            System.out.println("Error filter: " + this.getClass().getName());
        }
    }

    protected void setNetPage(String nextPage) {
        this.nextPage = nextPage;
    }

    public String getNextPage() {
        return nextPage;
    }
}
