package fw.facade;

import java.io.IOException;
import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;

import javax.servlet.FilterChain;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;

public class ChainFilter implements FilterChain {

    private List<AbstractFilter> filters;
    private Iterator<AbstractFilter> itFilters;
    private String nextPage;

    public ChainFilter() {
        itFilters = null;
        filters = new ArrayList<AbstractFilter>();
        addFilter(new FacesFilter());
        nextPage = null;
    }

    public ChainFilter(List<AbstractFilter> flt) {
        itFilters = null;
        filters = flt;
        nextPage = null;
    }

    public void addFilter(AbstractFilter f) {
        filters.add(f);
    }

    public boolean hasNext() {
        if (itFilters == null) {
            return false;
        } else {
            return itFilters.hasNext();
        }
    }

    public String getNextPage() {
        return nextPage;
    }

    public void setNextPage(String nextPage) {
        this.nextPage = nextPage;
    }

    @Override
    public void doFilter(ServletRequest request, ServletResponse response)
            throws IOException, ServletException {
        if (itFilters == null) {
            itFilters = filters.iterator();
        }
        if (hasNext()) {
            itFilters.next().doFilter(request, response, this);
        } else {
            String Page = (new ApplicationController()).doApplicationController(request, response);
            if (Page != null) {
                nextPage = Page;
            }
        }
    }
}
