package fw.facade;

import fw.action.Action;
import fw.action.ActionForm;
import fw.action.mapAction;
import java.util.*;

public class Factory {

    static final String PACKAGE_ACTION = "tfc.example.actions";
    static final String PACKAGE_FORM = "tfc.example.actionForms";
    static final String PACKAGE_JSP = "tfc.example.jspForms";
    private static Factory f;
    Hashtable<String, Action> actions;
    Hashtable<String, ActionForm> forms;
    Hashtable<String, mapAction> jspForms;

    public Factory() {
        this.actions = new Hashtable<String, Action>();
        this.forms = new Hashtable<String, ActionForm>();
        this.jspForms = new Hashtable<String, mapAction>();
    }

    public static Factory getReference() {
        if (f == null) {
            f = new Factory();
        }
        return f;
    }

    public Action getAction(String param) {
        Action action = this.actions.get(param);
        if (action == null) {
            action = newAction(param);
            this.actions.put(param, action);
        }
        return action;
    }

    private Action newAction(String param) {

        String nomClass = this.PACKAGE_ACTION + "." + param;
        Class c;
        Action o = null;
        try {
            c = Class.forName(nomClass);
            o = (Action) c.newInstance();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return o;
    }

    public ActionForm getActionForm(String param) {
        ActionForm form = this.forms.get(param);
        if (form == null) {
            form = newForm(param);
            this.forms.put(param, form);
        }
        return form;
    }

    private ActionForm newForm(String param) {

        String nomClass = this.PACKAGE_FORM + "." + param + "Form";
        Class c;
        ActionForm o = null;
        try {
            c = Class.forName(nomClass);
            o = (ActionForm) c.newInstance();
        } catch (Exception e) {
            e.getMessage();
            System.out.println("Error in ActionForm " + param);
        }
        return o;
    }

    public mapAction getJspForm(String param) {
        mapAction form = this.jspForms.get(param);
        if (form == null) {
            form = newJspForm(param);
            this.jspForms.put(param, form);
        }
        return form;
    }

    private mapAction newJspForm(String param) {

        String nomClass = this.PACKAGE_JSP + "." + param + "Form";
        Class c;
        mapAction o = null;
        try {
            c = Class.forName(nomClass);
            o = (mapAction) c.newInstance();
        } catch (Exception e) {
            e.getMessage();
            System.out.println("Error in Jsp " + param);
        }
        return o;
    }
}
