package fw.facade;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class Servlet extends HttpServlet {

    private List<AbstractFilter> filters;

    public Servlet() {
        super();
        filters = new ArrayList<AbstractFilter>();
        filters.add(new FacesFilter());

    }

    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {

        String nextPage = null;
        try {
            ChainFilter FilterCh = new ChainFilter(filters);
            FilterCh.doFilter(request, response);
            nextPage =FilterCh.getNextPage();
        } catch (Throwable t) {
            t.getMessage();
        }
        RequestDispatcher rd = getServletContext().getRequestDispatcher(response.encodeURL(nextPage));
        rd.forward(request, response);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp)
            throws ServletException, IOException {
        doGet(req, resp);
    }
}
